//
//  main: executes all examples
//  jsonserial - Eric Lecolinet
// See: https://www.telecom-paris.fr/~elc/jsonserial/
//

#include <iostream>
#include "main.hpp"

int main() {
#if 1
  // SAVE IN streambuffer

  std::cout << "\n*** Example 1: Basics *************************\n" << std::endl;
  basics::test_stream();

  std::cout << "\n*** Example 2: Cyclic Graph *************************\n" << std::endl;
  cyclic_graph::test_stream();

  std::cout << "\n*** Example 3: Inheritance *************************\n" << std::endl;
  inheritance::test_stream();

  std::cout << "\n*** Example 4: Smart Pointers *************************\n" << std::endl;
  smart_pointers::test_stream();

  std::cout << "\n*** Example 5: Custom class/member registration *************************\n" << std::endl;
  misc_registration::test_stream();

#else
  // SAVE IN data.json

  std::cout << "\n*** Example 1: Basics *************************\n" << std::endl;
  basics::test_file("data1.json");

  std::cout << "\n*** Example 2: Cyclic Graph *************************\n" << std::endl;
  cyclic_graph::test_file("data2.json");

  std::cout << "\n*** Example 3: Inheritance *************************\n" << std::endl;
  inheritance::test_file("data3.json");

  std::cout << "\n*** Example 4: Smart Pointers *************************\n" << std::endl;
  smart_pointers::test_file("data4.json");

  std::cout << "\n*** Example 5: Custom class/member registration *************************\n" << std::endl;
  misc_registration::test_file("data5.json");
#endif

  std::cout << "\nDone!\n" << std::endl;
  return 0;
}
